#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin>>n;
    vector<int> a(n);
    for(int i=0;i<n;i++)
        cin>>a[i];
    int q,l,r;
    cin>>q;
    while(q--)
    {
        cin>>l>>r;
        l--,r--;
        if(l==r)
        {
            cout << "DA" << endl;
            continue;
        }
        int cnt=0,Max=a[l],Maxp=0;
        for(int i=l+1;cnt<2&&i<=r;i++)
        {
            if(a[i]<Max&&a[i]<Maxp)
                cnt++;
            else if(a[i]<Max)
                Max=a[i],cnt++;
            else
                Maxp=Max,Max=a[i];
        }
        if(cnt<2)
            cout << "DA" << endl;
        else
            cout << "NE" << endl;
    }
    return 0;
}